<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" import="fr.cirad.web.controller.security.UserPermissionController,fr.cirad.security.base.IRoleDefinition,org.springframework.security.core.context.SecurityContextHolder" %>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<jsp:useBean id="urlEncoder" scope="page" class="fr.cirad.web.controller.security.UserPermissionController" /><%-- dummy controller just to be able to invoke a static method --%>
<c:set var='roleSep' value='<%= UserPermissionController.ROLE_STRING_SEPARATOR %>' />
<c:set var="loggedUser" value="<%= SecurityContextHolder.getContext().getAuthentication().getPrincipal() %>" />
<c:set var='adminRole' value='<%= IRoleDefinition.ROLE_ADMIN %>' />
<c:set var='entityManagerRole' value='<%= IRoleDefinition.ENTITY_MANAGER_ROLE %>' />
<c:set var='isManager' value="${fn:contains(user.authorities, param.module.concat(roleSep).concat(param.entityType).concat(roleSep).concat(entityManagerRole).concat(roleSep).concat(entity.key))}" />

<html>

<head>
	<script type="text/javascript" src="../js/jquery-1.12.4.min.js"></script>
	<link rel ="stylesheet" type="text/css" href="../css/role_manager.css" title="style">
	<script type="text/javascript">
		function doOnLoad(module)
		{
			var permissionInput = $(window.parent.document).find("input[type='hidden'][name='${param.entityType}Permission_" + module + "']");
			$('input[type="radio"][value=""]').each(function() {$(this).attr('checked', true);});
	    	var permissions = permissionInput.val().split(",");
	    	for (var i=0; i<permissions.length; i++)
	    	{
					var radioButton = $('input[type="radio"][value="' + permissions[i] + '"]');
	    			radioButton.attr('checked', true);
	    			<c:if test="${!fn:contains(loggedUser.authorities, adminRole) && isManager}">
	    			if (permissions[i].indexOf("${entityManagerRole}") != -1)
	    				radioButton.parent().siblings().remove();
	    			</c:if>
	    	}
		}

		function toggleEntityBoxes(entityBoxContainerId, enableThem)
		{
			$(entityBoxContainerId + " input").each(function() {
				$(this).attr('disabled', !enableThem);
				if (!enableThem)
					$(this).attr('checked', false);
			});
		}
	</script>
</head>

<body style='background-color:#f0f0f0; text-align:center;' onload="doOnLoad('${urlEncoder.urlEncode(param.module)}');">
	<form>
		<table cellpadding='4' cellspacing='0' border='0'>
		  <tr>
		    <td width='5'>&nbsp;</td>
			<th style='background-color:#AEA;' valign='top'>
			  Public ${param.entityType} entities
			  <table cellpadding='2' cellspacing='0' class='adminListTable'>
				<tr>
					<th>${param.entityType} name</th>
					<th>${param.entityType} permissions</th>
				</tr>
				<c:forEach var="entity" items="${publicEntities}">
				<c:if test="${fn:contains(loggedUser.authorities, adminRole) || fn:contains(loggedUser.authorities, param.module.concat(roleSep).concat(param.entityType).concat(roleSep).concat(entityManagerRole).concat(roleSep).concat(entity.key))}">
				<tr>
					<td>${entity.value}</td>
					<td nowrap align='center'>
						<c:forEach var="role" items="${roles}">
							<span>
							<input type='radio' name='permission_${entity.key}' value='${urlEncoder.urlEncode(param.module.concat(roleSep).concat(param.entityType).concat(roleSep).concat(role).concat(roleSep).concat(entity.key))}'>${role}
							</span>
						</c:forEach>
						<span>
							<input type='radio' name='permission_${entity.key}' value=''>NONE
						</span>
					</td>
				</tr>
				</c:if>
				</c:forEach>
			  </table>
			</th>
			<c:if test="${privateEntities ne null}">
			<th style='background-color:#AEA;' valign='top'>
			  Private ${param.entityType} entities
			  <table cellpadding='2' cellspacing='0' class='adminListTable'>
				<tr>
					<th>${param.entityType} name</th>
					<th>${param.entityType} permissions</th>
				</tr>
				<c:forEach var="entity" items="${privateEntities}">
				<c:if test="${fn:contains(loggedUser.authorities, adminRole) || fn:contains(loggedUser.authorities, param.module.concat(roleSep).concat(param.entityType).concat(roleSep).concat(entityManagerRole).concat(roleSep).concat(entity.key))}">
				<tr>
					<td>${entity.value}</td>
					<td nowrap align='center'>
						<c:forEach var="role" items="${roles}">
							<span>
							<input type='radio' name='permission_${entity.key}' value='${urlEncoder.urlEncode(param.module.concat(roleSep).concat(param.entityType).concat(roleSep).concat(role).concat(roleSep).concat(entity.key))}'>${role}
							</span>
						</c:forEach>
						<span>
							<input type='radio' name='permission_${entity.key}' value=''>NONE
						</span>
					</td>
				</tr>
				</c:if>
				</c:forEach>
			  </table>
			</th>
			</c:if>
		  </tr>
		</table>
	</form>
</body>

</html>