<%@ page language="java" contentType="text/html; charset=utf-8" import="fr.cirad.web.controller.gigwa.GigwaRestController" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="sec" uri="http://www.springframework.org/security/tags" %>
<sec:authentication property="principal" var="principal"/>
<sec:authorize access="hasRole('ROLE_ADMIN')" var="isAdmin"/>
<sec:authorize access="hasRole('ROLE_ANONYMOUS')" var="isAnonymous"/>

    <script>
    	var token;
    	
        function reloadContext() {
            $.ajax({
                url: '<c:url value="<%=GigwaRestController.REST_PATH + GigwaRestController.BASE_URL + GigwaRestController.RELOAD_CONTEXT_PATH%>"/>',
                type: "GET",
                dataType: "json",
                contentType: "application/json;charset=utf-8",
                headers: {
                    "Authorization": "Bearer " + token
                },
                success: function (jsonResult) {
                    if (jsonResult.success === true) {
                        window.location.reload();
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    handleError(xhr, thrownError);
                }
            });
        }
    </script>
    <nav class="navbar navbar-inverse navbar-default<c:if test="${param.hideNavBar eq 'true'}"> hidden</c:if>">
        <div class="container-fluid">
            <div class="navbar-header">
                <a class="navbar-brand" href="<c:url value='/' />"><img src="<c:url value='/images/logo.png' />" height="25"></a>
            </div>
           	<div id="appVersionNumber">${appVersionNumber == "" ? "" : ("v".concat(appVersionNumber))}</div>
           	<div id="appVersionType">${appVersionType}</div>
            <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
                <ul class="nav navbar-nav navbar-right">
                    <li><a href="<c:url value='/rest/swagger-ui.html' />" target="_blank" data-toggle="tooltip" data-placement="bottom" title="Rest API documentation"><span class="glyphicon glyphicon-leaf margin-icon" aria-hidden="true"></span>Rest APIs</a></li>
                    <li>
                        <a href="<c:url value='<%=/*GigwaRestController.REST_PATH + GigwaRestController.BASE_URL +*/ GigwaRestController.IMPORT_PAGE_URL%>' />" id="import" onclick="window.location.href = this.href" data-toggle="tooltip" data-placement="bottom" title="Import data"><span class="glyphicon glyphicon-save margin-icon" aria-hidden="true"></span>Import</a>
                    </li>
                    <c:if test="${userDao.doesLoggedUserOwnEntities()}">
   			   			<li>
   			   				<a href="<c:url value='/permissionManagement.jsp' />" data-toggle="tooltip" data-placement="bottom" title="Configure users' access to data"><span class="glyphicon glyphicon-share margin-icon" aria-hidden="true"></span>Manage data</a>
   			   			</li>
					</c:if>
<%--                     <c:if test="${principal == null || isAdmin}"> --%>
<!--                         <li> -->
<!--                             <a href="#" id="reload" data-toggle="tooltip" data-placement="bottom" title="Reload database list and permissions" onclick="reloadContext();"><span class="glyphicon glyphicon-refresh margin-icon" aria-hidden="true"></span>Refresh</a> -->
<!--                         </li> -->
<%--                    </c:if> --%>
<!--                    <li><a href="#" data-toggle="tooltip" data-placement="bottom" title="Online tutorial"><span class="glyphicon glyphicon-question-sign margin-icon" aria-hidden="true"></span>Help</a></li> -->
                    <c:if test="${principal != null && isAnonymous}">
                        <li>
                            <a href="<c:url value='/login.jsp' />" data-toggle="tooltip" data-placement="bottom" title="Log-in for private data"><span class="glyphicon glyphicon-user margin-icon" aria-hidden="true"></span>Connexion</a>
                        </li>
					</c:if>
					<c:if test="${principal != null && !isAnonymous}">
                        <li>
                            <a href="<c:url value='/j_spring_security_logout' />" data-toggle="tooltip" data-placement="bottom" title="Log out ${principal.username}" id="logOut"><span class="glyphicon glyphicon-log-out margin-icon" aria-hidden="true"></span>Log out</a>
                        </li>
					</c:if>
                </ul>
                <form class="navbar-form navbar-left" role="search" id="moduleProjectNavbar">
                    <select class="selectpicker" id="module" data-actions-box="true" data-live-search="true" name="module" title="Database"></select>
                    <div class="form-group" id="grpProj">&nbsp;
                        <label for="project" class="label-light" id="projectLabel">Project </label>
                        <select class="selectpicker" id="project" data-actions-box="true" data-live-search="true" name="project"></select>
	                    <a href="#" onclick="displayProjectInfo($('#project').val());" id="projectInfoLink" style="display:none;"><span role='button' title="Click for project information" class="glyphicon glyphicon-info-sign" id="formatHelp" style="color:yellow;"></span></a>
                    </div>
                </form>
            </div>
        </div>
    </nav>